"""Add an email address or regexp to ban_list and discard_these_nonmembers 
for all lists

Save as bin/add_ban_list.py

To ban from all lists, run: 

   bin/withlist -a -r add_ban_list address_to_ban

To ban from a single list, run: 

    bin/withlist -r add_ban_list <listname> <address to ban>

where <address_to_ban> is the actual email address or regexp
to be added to ban_list for all lists.
"""

def add_ban_list(mlist, address):
    if not mlist.Locked():
        mlist.Lock()
    if address not in mlist.ban_list:
        mlist.ban_list.append(address)
    if address not in mlist.discard_these_nonmembers:
        mlist.discard_these_nonmembers.append(address)
    mlist.Save()
    mlist.Unlock()
