"""Remove pending approval requests from a mailing list.

This script remove pending requests sent by the given address from a mailing 
list.  It is intended to be run to remove spammer requests from the system. 
You can create a wrapper to feed list names. 

% bin/withlist -l -r del_sub_approvals <listname> <address>

Written by Xueshan Feng <sfeng@stanford.edu>

"""

from Mailman.mm_cfg import DISCARD
 
def del_sub_approvals(mlist, addr):
    pendingsubs = mlist.GetSubscriptionIds()
    if not pendingsubs:
        return 0
    for id in pendingsubs:
        requestaddr = mlist.GetRecord(id)[1]
        if requestaddr in ( addr ):
            print 'Discard listname: %s, addr: %s\n' % (mlist.real_name, requestaddr)
            # Comment this out if dry-run
            mlist.HandleRequest(id,DISCARD)
            mlist.Save()

